`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date: 2021/04/08 13:54:03
// Design Name: 
// Module Name: down_counter
// Project Name: 
// Target Devices: 
// Tool Versions: 
// Description: 
// 
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////


module down_counter(
    output reg [3:0] out1,
    output reg [3:0] out2,
    output reg [3:0] out3,
    output reg LED_ctl,
    input mode,
    input mode_re,
    input reset,
    input count_en,
    input clk,
    input rst_n
    );
    reg [3:0] cnt1_tmp1;
    reg [3:0] cnt1_tmp2;
    reg [3:0] cnt1_tmp3;
    reg [3:0] cnt2_tmp1;
    reg [3:0] cnt2_tmp2;
    reg [3:0] cnt2_tmp3;
    reg [3:0] cnt3_tmp1;
    reg [3:0] cnt3_tmp2;
    reg [3:0] cnt3_tmp3;
    reg borrow1;
    reg borrow2;
    
    always@*
    begin
        cnt1_tmp1 = out1;
        cnt1_tmp2 = out1 - 1'b1;
        cnt2_tmp1 = out2;
        cnt2_tmp2 = out2 - 1'b1;
        cnt3_tmp1 = out3;
        cnt3_tmp2 = out3 - 1'b1;
    end
    
    always@*
    if(out1 == 4'b0000 && out2 == 4'b0000 && out3 == 4'b0000)
        LED_ctl = 1'b1;
    else
        LED_ctl = 1'b0;
//unit of second
    always@*
        if(reset == 0 && mode_re == 0)
            if(out1 == 4'b0000 && count_en)
                if(out2 == 4'b0000 && out3 == 4'b0000)
                begin
                    cnt1_tmp3 = 4'b0000;
                    borrow1 = 1'b0;
                end
                else
                begin
                    cnt1_tmp3 = 4'b1001;
                    borrow1 = 1'b1;
                end
            else if(count_en)
            begin
                cnt1_tmp3 = cnt1_tmp2;
                borrow1 = 1'b0;
            end
            else
            begin
                cnt1_tmp3 = cnt1_tmp1;
                borrow1 = 1'b0;
            end
        else
            if(mode == 0)
            begin
                cnt1_tmp3 = 4'b0101;
                borrow1 = 1'b0;
            end
            else
            begin
                cnt1_tmp3 = 4'b0000;
                borrow1 = 1'b0;
            end
//tens of second    
    always@*
        if(reset == 0 && mode_re == 0)
            if(out2 == 4'b0000 && borrow1)
                if(out3 == 4'b0000)
                begin
                    cnt2_tmp3 = 4'b0000;
                    borrow2 = 1'b0;
                end
                else
                begin
                    cnt2_tmp3 = 4'b0101;
                    borrow2 = 1'b1;
                end
            else if(borrow1)
            begin
                cnt2_tmp3 = cnt2_tmp2;
                borrow2 = 1'b0;
            end
            else
            begin
                cnt2_tmp3 = cnt2_tmp1;
                borrow2 = 1'b0;
            end
        else
            if(mode == 0)
            begin
                cnt2_tmp3 = 4'b0010;
                borrow2 = 1'b0;
            end
            else
            begin
                cnt2_tmp3 = 4'b0011;
                borrow2 = 1'b0;
            end
// minute
    always@*
        if(reset == 0 && mode_re == 0)
            if(borrow2 && out3 == 4'b0000)
                cnt3_tmp3 = 4'b0000;
            else if(borrow2)
                cnt3_tmp3 = cnt3_tmp2;
            else
                cnt3_tmp3 = cnt3_tmp1;
        else
            if(mode == 0)
                cnt3_tmp3 = 4'b0000;
            else
                cnt3_tmp3 = 4'b0001;
   
    always@(posedge clk or negedge rst_n)
    if(~rst_n)
    begin
        out1<=4'b0101;
        out2<=4'b0010;
        out3<=4'b0000;
    end    
    else
    begin
        out1<=cnt1_tmp3;
        out2<=cnt2_tmp3;
        out3<=cnt3_tmp3;
    end
    
endmodule
