`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date: 2021/04/08 16:25:44
// Design Name: 
// Module Name: top_module
// Project Name: 
// Target Devices: 
// Tool Versions: 
// Description: 
// 
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////


module top_module(
    input clk,
    input rst_n,
    input button1,
    input button2,
    output [7:0] segs,
    output [3:0] ssd_ctl,
    output [15:0] LED
    );
    wire [1:0] scan_ctl;
    wire clk_1Hz;
    wire clk_16Hz;
    wire clk_64Hz;
    wire clk_100Hz;
    wire LED_ctl;
    wire [3:0] out1;
    wire [3:0] out2;
    wire [3:0] out3;
    wire count_en;
    wire pb_de1;
    wire pb_de2;
    wire pb_re;
    wire mode_re;
    wire one_pulse1;
    wire one_pulse2;
    wire start;
    wire mode;
    wire [3:0] ssd_in;
    
    freqdiv U0(.clk(clk),.rst_n(rst_n),.scan_ctl(scan_ctl),.clk_out(clk_1Hz),.clk_16Hz(clk_16Hz),.clk_64Hz(clk_64Hz),.clk_100Hz(clk_100Hz));
    down_counter U1(.clk(clk_1Hz),.rst_n(rst_n),.count_en(count_en),.reset(pb_re),.mode(mode),.mode_re(mode_re),.out1(out1),.out2(out2),.out3(out3),.LED_ctl(LED_ctl));
    debounce U2(.clk(clk_100Hz),.rst_n(rst_n),.pb_in(button1),.pb_de(pb_de1));
    debounce U3(.clk(clk_100Hz),.rst_n(rst_n),.pb_in(button2),.pb_de(pb_de2));
    reset U4(.clk(clk_16Hz),.rst_n(rst_n),.pb_in(button1),.pb_re(pb_re));
    reset U5(.clk(clk_64Hz),.rst_n(rst_n),.pb_in(button2),.pb_re(mode_re));
    pulse U6(.clk(clk_100Hz),.rst_n(rst_n),.pb_de(pb_de1),.one_pulse(one_pulse1));
    pulse U7(.clk(clk_100Hz),.rst_n(rst_n),.pb_de(pb_de2),.one_pulse(one_pulse2));
    fsm U8(.clk(clk_100Hz),.rst_n(rst_n),.signal(one_pulse1),.count_en(count_en),.state(start));
    fsm U9(.clk(clk_100Hz),.rst_n(rst_n),.signal(one_pulse2),.state(mode));
    scan_ctl U10(.out1(out1),.out2(out2),.out3(out3),.ssd_ctl_en(scan_ctl),.ssd_ctl(ssd_ctl),.ssd_in(ssd_in));
    display U11(.i(ssd_in),.D(segs));
    LED U12(.start(start),.mode(mode),.LED_ctl(LED_ctl),.led(LED));
    
endmodule
